import processing.video.*;

private int farbArray[] = new int[64];
private ArrayList<ChessFigure> figureList = new ArrayList<ChessFigure>();
private boolean abbruch = false;
public int schachfeldInPixel = 480;//480 by default
public int pixelAnfang;
public int pixelEnde;



public int[] berechneFarbDif()  //Die Kamera sieht an der Stelle (40|100) ein weißes Papier. Weiß hat normalerweise den rgb-Wert 255 255 255, Unter bestimmten Lichtverhältnissen verändern sich aber alle gemessenen Werte. Diese Veränderung wird eben hierdurch festgehalten und soll später noch verwendet.
{
  int x = 40;
  int y = 100;
  int loc = x + y*640;
  
  int whiteDifArray[] = new int[3];
  
          
  color currentColor = video.pixels[loc];
  
  float r = red(currentColor);
  float g = green(currentColor);
  float b = blue(currentColor);
  
  r = constrain(r, 0, 255);
  g = constrain(g, 0, 255);
  b = constrain(b, 0, 255);
  
  whiteDifArray[0] = (int)r;
  whiteDifArray[1] = (int)g;
  whiteDifArray[2] = (int)b;
  return whiteDifArray;
}


public int erstellePixelAnfang() //Sucht nach dem ersten Pixel, womite das Schachbrett anfängt
{
  pixelAnfang = 0;
  for(int y = 0; y < 240; y++) //Nur halber Screen, weil es manchmal zu Fehler kommen würde
  {
    for(int x = 0; x < 640; x++)
    {
      
      int loc = x + y*640;
          
      color currentColor = video.pixels[loc];
      
      float r = red(currentColor);
      float g = green(currentColor);
      float b = blue(currentColor);
      
      r = constrain(r, 0, 255);
      g = constrain(g, 0, 255);
      b = constrain(b, 0, 255);
      
      
      
      if(r < 20 && g < 20 && b < 20 && pixelAnfang == 0) //black
      {
        println(loc);
        if(  (red(video.pixels[loc+5]) > 20  ||  green(video.pixels[loc+5]) > 20  || blue(video.pixels[loc+5]) > 20)     &&     (red(video.pixels[loc+3200]) < 20  ||  green(video.pixels[loc+3200]) < 20  || blue(video.pixels[loc+3200]) > 20))
        {
          pixelAnfang = loc;
        }
      }
      if(pixelAnfang > 0)
      {
        break;
      }
    }
    if(pixelAnfang > 0)
      {
        break;
      }
  }
  return pixelAnfang;
}





public int erstellePixelEnde() //Sucht nach dem letzten Pixel, womite das Schachbrett endet
{
  pixelEnde = 0;
  for(int y = 479; y > 240; y--)
  {
    for(int x = 639; x > 0; x--)
    {
      
      int loc = x + y*640;
          
      color currentColor = video.pixels[loc];
      
      float r = red(currentColor);
      float g = green(currentColor);
      float b = blue(currentColor);
      
      r = constrain(r, 0, 255);
      g = constrain(g, 0, 255);
      b = constrain(b, 0, 255);
      
      
      
      if(r < 20 && g < 20 && b < 20 && pixelEnde == 0) //black
      {
        if(  (red(video.pixels[loc-5]) > 20  ||  green(video.pixels[loc-5]) > 20  || blue(video.pixels[loc-5]) > 20)     &&     (red(video.pixels[loc-3200]) < 20  ||  green(video.pixels[loc-3200]) < 20  || blue(video.pixels[loc-3200]) > 20))
        {
          pixelEnde = loc;
        }
      }
      if(pixelEnde > 0)
      {
        break;
      }
    }
    if(pixelEnde > 0)
      {
        break;
      }
  }
  return pixelEnde;
}







Capture video;

public void erstelleArray(int pA, int pE)//Erstellt ein 8x8 int-Array mit Informationen zu den Schachfiguren und ihren Positionen auf dem Brett.
{
  int feldNr = 0;
  
  int pAY = pA/640;
  int pAX = pA - 640*pAY;
  
  int pEY = pE/640;
  int pEX = pE - 640*pEY;
  
  int yDif = pEY - pAY;
  int xDif = pEX - pAX;  //Nur so ein paar Rechnungen, um das oben stehende zu ermöglichen
  

  
  
  for(int i = 0; i < 8; i++) //Aufteilung in 8 x 8 Felder
  {
    for(int j = 0; j < 8; j++)
    {
      for(int y = i*(yDif/8) + pAY; y < (i+1)*(yDif/8) - (480 - pEY); y++) //Die Pixel jedes der Felder werden abgescannt, dabei werden der "Anfangspixel und Endpixel" als Referenzpunkte für die Größe und Position des Feldes auf dem Bild genommen.
      {
        for(int x = j*(xDif/8) + pAX; x < (j+1)*(xDif/8) - (640 - pEX); x++)
        {
          feldNr = (8 * i) + j;
          
          int loc = x + y*640; //Ein-Dimensionale Zahl, welche für einen bestimmten Pixel steht //<>//
          
          color currentColor = video.pixels[loc]; //Farbe aus dem Pixel wird in currentcolor gespeichert
          
          float r = red(currentColor); //RGB Werte werden gespeichert
          float g = green(currentColor);
          float b = blue(currentColor);
          
          r = constrain(r, 0, 255); //RGB werden auf einen Wert zwischen 0 und 255 beschränkt
          g = constrain(g, 0, 255);
          b = constrain(b, 0, 255);
          
          
          //println(pAX + "|" + pAY); //TEST
          //println(pEX + "|" + pEY); //TEST
          //fill(255,0,0);
          //strokeWeight(4.0);
          //stroke(0);
          //ellipse(x, y, 24, 24);
          
          //println(feldNr);             //TEST
          
          //print("x: ");                //TEST
          //println(x);                  //TEST
          //print("y: ");                //TEST
          //println(y);                  //TEST
          //println("");                 //TEST
          
          
          if(r > 180 && g < 40 && b < 40) //rot, KING, WHITE  //Es wird nach dieser bestimmten farbe gesucht
          {
            fill(255,0,0); //Zur Markierung aufm Bildschirm
            strokeWeight(4.0); //Zur Markierung aufm Bildschirm
            stroke(0); //Zur Markierung aufm Bildschirm
            ellipse(x, y, 24, 24); //Zur Markierung aufm Bildschirm
            farbArray[feldNr] = 1; //Das 8x8 Array bekommt einen Wert entsprechend der Frabe die er gefunden hat, in diesem Fall rot und König Weiß
            abbruch = true; //Sorgt dafür, dass später auch aus der Zweiten Schleife gebrochen wird.
            break;
          }
          else if(r < 20 && g > 230 && b < 20) //grün, KING, BLACK
          {
            fill(0,255,0);
            strokeWeight(4.0);
            stroke(0);
            ellipse(x, y, 24, 24);
            farbArray[feldNr] = 2;
            abbruch = true;
            break;
          }
          else if(r < 20 && g < 20 && b > 230) //blau, QUEEN, WHITE
          {
            fill(0,0,255);
            strokeWeight(4.0);
            stroke(0);
            ellipse(x, y, 24, 24);
            farbArray[feldNr] = 3;
            abbruch = true;
            break;
          }
          else if(r > 230 && g > 230 && b < 20) //gelb, QUEEN, BLACK
          {
            fill(255,255,0);
            strokeWeight(4.0);
            stroke(0);
            ellipse(x, y, 24, 24);
            farbArray[feldNr] = 4;
            abbruch = true;
            break;
          }
          else if(r < 20 && g > 230 && b > 230) //türkis, ROOK, WHITE
          {
            fill(0,255,255);
            strokeWeight(4.0);
            stroke(0);
            ellipse(x, y, 24, 24);
            farbArray[feldNr] = 5;
            abbruch = true;
            break;
          }
          else if(r > 230 && g < 20 && b > 230) //purple, ROOK, BLACK
          {
            fill(255,0,255);
            strokeWeight(4.0);
            stroke(0);
            ellipse(x, y, 24, 24);
            farbArray[feldNr] = 6;
            abbruch = true;
            break;
          }
          else if(r > 190 && r < 230 && g < 125 && g > 85 && b > 10 && b > 50) //orange, BISHOP, WHITE
          {
            fill(220,105,30);
            strokeWeight(4.0);
            stroke(0);
            ellipse(x, y, 24, 24);
            farbArray[feldNr] = 7;
            abbruch = true;
            break;
          }
          else if(r > 204 && r < 244 && g > 82 && g < 102 && b > 230) //pink, BISHOP, BLACK
          {
            fill(224,102,255);
            strokeWeight(4.0);
            stroke(0);
            ellipse(x, y, 24, 24);
            farbArray[feldNr] = 8;
            abbruch = true;
            break;
          }
          else if(r > 119 && r < 159 && g > 51 && g < 91 && b > 18 && b < 58) //braun, KNIGHT, WHITE
          {
            fill(139,71,38);
            strokeWeight(4.0);
            stroke(0);
            ellipse(x, y, 24, 24);
            farbArray[feldNr] = 9;
            abbruch = true;
            break;
          }
          else if(r > 119 && r < 159 && g > 15 && g < 55 && b > 15 && b < 55) //dunkelrot, KNIGHT, BLACK
          {
            fill(139,35,35);
            strokeWeight(4.0);
            stroke(0);
            ellipse(x, y, 24, 24);
            farbArray[feldNr] = 10;
            abbruch = true;
            break;
          }
          else if(r > 119 && r < 159 && g < 20 && b > 119 && b < 159) //lila, PAWN, WHITE
          {
            fill(139,0,139);
            strokeWeight(4.0);
            stroke(0);
            ellipse(x, y, 24, 24);
            farbArray[feldNr] = 11;
            abbruch = true;
            break;
          }
          else if(r > 230 && g > 230 && b > 230)//white, PAWN, BLACK
          {
            fill(224);
            strokeWeight(4.0);
            stroke(0);
            ellipse(x, y, 24, 24);
            farbArray[feldNr] = 12;
            abbruch = true;
            break;
          }
          
          
          
    
        }
          if(abbruch == true)
          {
            abbruch = false;
            break;
          }
      }
      
    }
    
  }
  printArray(farbArray);
}

public void arrayToArrayList()//Wandelt das Array in eine ArrayList um, welche die KI benötigt, die Mathematik dahinter sollte ziemlich selbsterklärend sein.
{
  for(int i = 0; i < 64; i++)
  {
    if(farbArray[i] > 0)
    {
      int posX = i % 8;
      
      
      int posY = 0;
      
      
      if((i / 8) < 1)
      {
        posY = 0;
      }
      else if((i / 8) < 2)
      {
        posY = 1;
      }
      else if((i / 8) < 3)
      {
        posY = 2;
      }
      else if((i / 8) < 4)
      {
        posY = 3;
      }
      else if((i / 8) < 5)
      {
        posY = 4;
      }
      else if((i / 8) < 6)
      {
        posY = 5;
      }
      else if((i / 8) < 7)
      {
        posY = 6;
      }
      else if((i / 8) < 8)
      {
        posY = 7;
      }
      
      
      ChessFigureColor clr = ChessFigureColor.WHITE;     //WHITE BY DEFAULT
      ChessFigureType type = ChessFigureType.PAWN;       //PAWN BY DEFAULT
      
      
      if(farbArray[i] == 1)
      {
        clr = ChessFigureColor.WHITE;
        type = ChessFigureType.KING;
      }
      else if(farbArray[i] == 2)
      {
        clr = ChessFigureColor.BLACK;
        type = ChessFigureType.KING;
      }
      else if(farbArray[i] == 3)
      {
        clr = ChessFigureColor.WHITE;
        type = ChessFigureType.QUEEN;
      }
      else if(farbArray[i] == 4)
      {
        clr = ChessFigureColor.BLACK;
        type = ChessFigureType.QUEEN;
      }
      else if(farbArray[i] == 5)
      {
        clr = ChessFigureColor.WHITE;
        type = ChessFigureType.ROOK;
      }
      else if(farbArray[i] == 6)
      {
        clr = ChessFigureColor.BLACK;
        type = ChessFigureType.ROOK;
      }
      else if(farbArray[i] == 7)
      {
        clr = ChessFigureColor.WHITE;
        type = ChessFigureType.BISHOP;
      }
      else if(farbArray[i] == 8)
      {
        clr = ChessFigureColor.BLACK;
        type = ChessFigureType.BISHOP;
      }
      else if(farbArray[i] == 9)
      {
        clr = ChessFigureColor.WHITE;
        type = ChessFigureType.KNIGHT;
      }
      else if(farbArray[i] == 10)
      {
        clr = ChessFigureColor.BLACK;
        type = ChessFigureType.KNIGHT;
      }
      else if(farbArray[i] == 11)
      {
        clr = ChessFigureColor.WHITE;
        type = ChessFigureType.PAWN;
      }
      else if(farbArray[i] == 12)
      {
        clr = ChessFigureColor.BLACK;
        type = ChessFigureType.PAWN;
      }
      
      byte positionX = (byte) posX; 
      byte positionY = (byte) posY;
      ChessFigure cf = new ChessFigure(type, clr, positionX, positionY);
      figureList.add(cf);
    }
    
  }
}

public ArrayList<ChessFigure> getFigureList()
{
  return figureList;
}

 //<>//
void setup()
{
  size(640,480);
  video = new Capture(this,640,480,30);
  video.start();
  
  //erstellePixelAnfang();
  //erstellePixelEnde();
  //erstelleArray(pixelAnfang, pixelEnde);          //TEST
  //arrayToArrayList();       //TEST

}

void captureEvent(Capture video)
{
  video.read();
}

void draw()
{
  //background(0);
  //video.loadPixels();
  //image(video,0,0,640,480);
  copy(video,0,0,640,480,0,0,640,480);
  //delay(100);
  erstellePixelAnfang();
  erstellePixelEnde();
  erstelleArray(pixelAnfang,pixelEnde);
  arrayToArrayList();
  
                                     
  
  //for(int y = 0; y < 480; y++)                                   //TEST
  //{                                                              //TEST
  //  for(int x = 0; x < 480; x++)                                 //TEST
  //  {       
  //    int loc = x + y*640;                                       //TEST
          
  //    color currentColor = video.pixels[loc];
  //    //println(video.pixels.length);//TEST
  
  //    float r = red(currentColor);                               //TEST
  //    float g = green(currentColor);                             //TEST
  //    float b = blue(currentColor);                              //TEST
       
  //    r = constrain(r, 0, 255);                                  //TEST
  //    g = constrain(g, 0, 255);                                  //TEST
  //    b = constrain(b, 0, 255);                                  //TEST
      
  //    if(r > 160 && g < 80 && b < 80) //rot, KING, WHITE         //TEST
  //        {                                                      //TEST
  //          fill(255,0,0);                                       //TEST
  //          strokeWeight(4.0);                                   //TEST
  //          stroke(0);                                           //TEST
  //          ellipse(x, y, 1, 1);
  //          print(x);
  //    println(" " + y);
  //        }                                                      //TEST
  //  }                                                            //TEST
  //}                                                              //TEST
  delay(100);
  
}